#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>

Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();                          // called this way, it uses the default address 0x40

#define red 0                                                                     //create a const. variable named "red" with value 0.
#define green 1                                                                   //create a const. variable named "green" with value 1.
#define blue 2                                                                    //create a const. variable named "blue" with value 2.

#define ledMin 0                                                                  //create a const. variable named "ledMin" with value 0.
#define ledMax 4095                                                               //create a const. variable named "ledMax" with value 4095.

int sensorReading = 0;                                                            //create variable named "sensorReading" with initial value 0. this variable will hold the sensore reading value.
float volts;                                                                      //create an float variable to hold the volts conversion value of the sensor reading
float temp;                                                                       //create an float variable to hold the celecius conversion value of the sensor reading 
int mapped;                                                                       //create an integer variable to hold the conversion value of the sensor reading after remapping.

void setup() {

  pwm.begin();                                                                    //Setups the I2C interface and hardware.
  delay(10);                                                                      //wait 10 milliseconds.
}


void loop() {
//***********************************************red LED*****************************************************
  for(int pulseLen = ledMin ; pulseLen <= ledMax ; pulseLen++){                    //create a for loop starts counting from 0 to 4095, at each iteration the "pulseLen" variable is increased by one
    pwm.setPin(red, pulseLen);                                                     //write the "pulseLen" value to the red LED.
  }
  
  delay(10);                                                                       //wait 10 milliseconds.

  for(int pulseLen = ledMax ; pulseLen >= ledMin ; pulseLen--){                    //create a for loop starts counting from 4095 to 0, at each iteration the "pulseLen" variable is decreased by one
    pwm.setPin(red, pulseLen);                                                     //write the "pulseLen" value to the red LED.
  }

  //***********************************************green LED*****************************************************
  for(int pulseLen = ledMin ; pulseLen <= ledMax ; pulseLen++){
    pwm.setPin(green, pulseLen);
  }
  
  delay(10);

  for(int pulseLen = ledMax ; pulseLen >= ledMin ; pulseLen--){
    pwm.setPin(green, pulseLen);
  }  
  //****************************************************blue LED********************************************************
    for(int pulseLen = ledMin ; pulseLen <= ledMax ; pulseLen++){
    pwm.setPin(blue, pulseLen);
  }
  delay(10);

  for(int pulseLen = ledMax ; pulseLen >= ledMin ; pulseLen--){
    pwm.setPin(blue, pulseLen);
  }
}
